###############################
# Setup
###############################

###############################
# Include the template scripts
###############################

variables:
  PROJECT: ${MODULE}-test
  DEPENDENCIES: ${MODULE}
  VERSION: "1.0"
  MAINTAINER: "dune-archiso@gitlab.com"

include:
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module.repo.yaml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/build.yml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/load.yml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/pages.yml"

###############################
# Build from local PKGBUILD
###############################

build_dune-common-git:
  extends: .build_aur_template
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-common-git"
    ISDUNEOPTS: "true"
    DUNE_VERSION: "2.10.r11636.534337714"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  # artifacts:
  #   reports:
  #     junit:
  #       - ${CI_PROJECT_DIR}/junit/*-cmake.xml
  #   paths:
  #     - ${CI_PROJECT_DIR}/x86_64/

###############################
# Build from local PKGBUILD
###############################

build_dune-istl-git:
  extends: .build_aur_template
  stage: start
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-istl-git"
    ISDUNEOPTS: "true"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst python-dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst"
    DUNE_VERSION: "2.10.r3476.59188482"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  # artifacts:
  #   reports:
  #     junit:
  #       - ${CI_PROJECT_DIR}/junit/*-cmake.xml
  #   paths:
  #     - ${CI_PROJECT_DIR}/x86_64/
  needs: ["build_dune-common-git"]

###############################
# Build from local PKGBUILD
###############################

build_dune-geometry-git:
  extends: .build_aur_template
  stage: start
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-geometry-git"
    ISDUNEOPTS: "true"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst python-dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst"
    DUNE_VERSION: "2.10.r1203.81122d3"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  # artifacts:
  #   reports:
  #     junit:
  #       - ${CI_PROJECT_DIR}/junit/*-cmake.xml
  #   paths:
  #     - ${CI_PROJECT_DIR}/x86_64/
  needs: ["build_dune-common-git"]

###############################
# Build from local PKGBUILD
###############################

build_dune-localfunctions-git:
  extends: .build_aur_template
  stage: build
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-localfunctions-git"
    ISDUNEOPTS: "true"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst python-dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst dune-geometry-git-2.10.r1203.81122d3-*.pkg.tar.zst python-dune-geometry-git-2.10.r1203.81122d3-*.pkg.tar.zst"
    DUNE_VERSION: "2.10.r1850.8ad06c5b"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  # artifacts:
  #   reports:
  #     junit:
  #       - ${CI_PROJECT_DIR}/junit/*-cmake.xml
  #   paths:
  #     - ${CI_PROJECT_DIR}/x86_64/
  needs: ["build_dune-common-git", "build_dune-geometry-git"]

###############################
# Build from local PKGBUILD
###############################

build_dune-grid-git:
  extends: .build_aur_template
  stage: build
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-grid-git"
    ISDUNEOPTS: "true"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst python-dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst dune-geometry-git-2.10.r1203.81122d3-*.pkg.tar.zst python-dune-geometry-git-2.10.r1203.81122d3-*.pkg.tar.zst"
    DUNE_VERSION: "2.10.r11494.5ee8784d1"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-staging-git]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging-git/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  # artifacts:
  #   reports:
  #     junit:
  #       - ${CI_PROJECT_DIR}/junit/*-cmake.xml
  #   paths:
  #     - ${CI_PROJECT_DIR}/x86_64/
  needs: ["build_dune-common-git", "build_dune-geometry-git"]

###############################
# Build from local PKGBUILD
###############################

build_dune-core-git:
  extends: .build_aur_template
  stage: meta
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-core-git"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst python-dune-common-git-2.10.r11636.534337714-*.pkg.tar.zst dune-geometry-git-2.10.r1203.81122d3-*.pkg.tar.zst python-dune-geometry-git-2.10.r1203.81122d3-*.pkg.tar.zst dune-grid-git-2.10.r11494.5ee8784d1-*.pkg.tar.zst python-dune-grid-git-2.10.r11494.5ee8784d1-*.pkg.tar.zst dune-istl-git-2.10.r3476.59188482-*.pkg.tar.zst python-dune-istl-git-2.10.r3476.59188482-*.pkg.tar.zst dune-localfunctions-git-2.10.r1850.8ad06c5b-*.pkg.tar.zst python-dune-localfunctions-git-2.10.r1850.8ad06c5b-*.pkg.tar.zst"
    DUNE_VERSION: "git"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-staging-git]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging-git/$arch\n' | sudo tee -a /etc/pacman.conf
  needs:
    [
      "build_dune-common-git",
      "build_dune-geometry-git",
      "build_dune-grid-git",
      "build_dune-istl-git",
      "build_dune-localfunctions-git",
    ]

###############################
# Create custom repository
###############################

load_repository_dune_core_git_modules:
  extends: .load_repository_template
  stage: load_repository
  dependencies:
    [
      "build_dune-common-git",
      "build_dune-geometry-git",
      "build_dune-grid-git",
      "build_dune-istl-git",
      "build_dune-localfunctions-git",
      "build_dune-core-git",
    ]

###############################
# Upload to GitLab repo (pages)
###############################

pages:
  extends: .pages_template
  stage: deploy
  variables:
    TARGET_FOLDER: "x86_64"
  needs: ["load_repository_dune_core_git_modules"]
